<template>
  <div class="edit">
    <router-link to="/recipes">Index</router-link>
    <router-link v-bind:to="'/recipes/show/'+recipe.uuid">Show</router-link>
    <h3>Update recipe</h3>

    <form v-on:submit="updateRecipe">
      <div class="row">
        <div class="form-group col-6">
            <label>Title</label>
            <input type="text" class="form-control" v-model="recipe.title">
        </div>
        <div class="form-group col-6">
            <label>Description</label>
            <input type="text" class="form-control" v-model="recipe.description">
        </div>
      </div>

      <div class="row">
        <div class="form-group col-4">
            <label>Servings</label>
            <input type="number" class="form-control" v-model="recipe.servings">
        </div>

        <div class="form-group col-4">
            <label>Preparation Time</label>
            <input type="number" step="0.01" class="form-control" v-model="recipe.prepTime">
        </div>

        <div class="form-group col-4">
            <label>Cook Time</label>
            <input type="number" class="form-control" v-model="recipe.cookTime">
        </div>
      </div>

      <div class="row">
        <div class="form-group col-4">
            <label>Post Date</label>
            <input type="text" class="form-control" v-model="recipe.postDate">
        </div>

        <div class="form-group col-4">
            <label>Edit Date</label>
            <input type="text" class="form-control" v-model="recipe.editDate">
        </div>
      </div>

      <button type="submit" class="btn btn-primary">Submit</button>
    </form>

    <form v-on:submit="addIngredient(ingredient)">
        Name: <input type="string" class="form-control" v-model="ingredient.name" id="name"/>
        Amount: <input type="string" class="form-control" v-model="ingredient.amount" id="amount" />
        Measurement: <input type="string" class="form-control" v-model="ingredient.measurement" id="measurement"/>
        <button type="submit" class="btn btn-primary">Submit</button>
        <button type="reset" class="btn btn-primary" ref="ingredientReset">Reset</button>
    </form>

    <h3>Current Ingredients:</h3>
    <section>
      <div v-for="x in recipe.ingredients" :key="x.uuid" >
        {{x.name}}
      </div>
    </section>
  </div>

</template>

<script>
export default {
  name: 'edit',
  data () {
    return {
      recipe: {},
      ingredient: {
        name: '',
        amount: '',
        measurement: ''
      }
    }
  },
  methods: {
    blankIt () {
      this.ingredient = {ingredient: {
        name: '',
        amount: '',
        measurement: ''
      }}
    },
    fetchRecipe (uuid) {
      this.$http
        .get('http://localhost:3001/recipes/' + uuid)
        .then(function (response) {
          this.recipe = response.body
        })
    },
    addIngredient (ingredient) {
      this.recipe.ingredients.push(ingredient)
      let updatedRecipe = {
        title: this.recipe.title,
        description: this.recipe.description,
        servings: this.recipe.servings,
        prepTime: this.recipe.prepTime,
        cookTime: this.recipe.cookTime,
        postDate: this.recipe.postDate,
        editDate: this.recipe.editDate,
        ingredients: this.recipe.ingredients
      }
      this.$http
        .patch('http://localhost:3001/recipes/' + this.$route.params.id, updatedRecipe)
        .then(this.blankIt(), this.$router.push({path: '/recipes/update/' + this.$route.params.id}))
      event.preventDefault()
    },
    updateRecipe (event) {
      if (
        !this.recipe.title
      ) {
        window.alert('Please fill in all required fields')
      } else {
        let updatedRecipe = {
          title: this.recipe.title,
          description: this.recipe.description,
          servings: this.recipe.servings,
          prepTime: this.recipe.prepTime,
          cookTime: this.recipe.cookTime,
          postDate: this.recipe.postDate,
          editDate: this.recipe.editDate
        }
        this.$http
          .patch('http://localhost:3001/recipes/' + this.$route.params.id, updatedRecipe)
          .then(this.$router.push({path: '/recipes/show/' + this.$route.params.id}))
        event.preventDefault()
      }
      event.preventDefault()
    }
  },
  created: function () {
    this.fetchRecipe(this.$route.params.id)
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
